<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/2.0.4/css/dataTables.bootstrap4.min.css"> 
  <script src="https://cdn.datatables.net/2.0.4/js/dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/2.0.4/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
<div class="container">
  <div class="text-center mt-2 mb-2">
    <h2>F120 - Quản trị Order</h2>
  </div>
  <div class="jumbotron container">
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="voucherCodeInput">Loại Pizza</label>
      </div>
      <div class="col-sm-6">
        <select id="gPizzaTypeSelect" class="form-control">

        </select>
      </div>
      <div class="col-sm-3">
        <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
      </div>
    </div>
</div>

<div class="container">
  <table class="table table-bordered table-striped table-hover" id="order-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã order</th>
        <th>Loại Pizza</th>
        <th>Tên khách hàng</th>
        <th>Ngày đặt hàng</th>
        <th>Trạng thái</th>
        <th>Action</th>
      </tr>
    </thead>
  </table>
</div>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // mảng orders
  var gOrderObjects = [
      {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
      },
      {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
      },
      {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
      },
      {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
      },
      {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
      }
    ];
  
  // mảng pizza Type
  var gPizzaType = [
    {
      typeId: 10,
      typeName: "Hải Sản"
    },
    {
      typeId: 15,
      typeName: "Bò bít tết"
    },
    {
      typeId: 20,
      typeName: "Thịt gà"
    }
  ];
  
  var gCOL_NAMES = ["id", "orderCode", "gPizzaTypeId", "customerName", "date", "status", "action"];
  var gCOL_ID = 0;
  var gCOL_ORDER_CODE = 1;
  var gCOL_PIZZA_TYPE_ID = 2;
  var gCOL_CUSTOMER_NAME = 3;
  var gCOL_DATE = 4;
  var gCOL_STATUS = 5;
  var gCOL_ACTION = 6;
  var gSTT = 0;
  var gOrderDataTable = $("#order-table").DataTable({
    columns:[
      {data:gCOL_NAMES[gCOL_ID]},
      {data:gCOL_NAMES[gCOL_ORDER_CODE]},
      {data:gCOL_NAMES[gCOL_PIZZA_TYPE_ID]},
      {data:gCOL_NAMES[gCOL_CUSTOMER_NAME]},
      {data:gCOL_NAMES[gCOL_DATE]},
      {data:gCOL_NAMES[gCOL_STATUS]},
      {data:gCOL_NAMES[gCOL_ACTION]}
    ],
    columnDefs:[
      {
        targets:gCOL_ID,
        render:function() {
          return ++gSTT;
        }
      },
      {
        targets:gCOL_PIZZA_TYPE_ID,
        render:function(pizzaTypeId) {
          return getPizzaNameByTypeId(pizzaTypeId);
        }
      },      
      {
        targets:gCOL_ACTION,
        defaultContent:`<i class="fas fa-edit" style="color: green; font-size: 20px;cursor:pointer">
          <i class="fas fa-trash-alt" style="color: red; font-size: 20px;cursor:pointer"></i>`
      }      
    ]
  })
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  //sự kiện load trang
  onPageLoading();

  //thêm sự kiện click cho button filter 
  $("#btn-filter-order").click(function() {
    onBtnFilterOrderClick();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  //hàm xử lý sự kiện load trang
  function onPageLoading() {
    //Load dữ liệu vào table
    loadOrderDataToTable(gOrderObjects);

    //load dữ liệu pizza và filter box
    loadPizzaTypeToSelectBox(gPizzaType);
  }

  //hàm xử lý sự kiện filter
  function onBtnFilterOrderClick() {
    //B0: khai báo dữ liệu
    var vPizzaFilterObj = {
      pizzaTypeId:0
    }

    //B1: thu thập dữ liệu
    getFilterData(vPizzaFilterObj);

    //B2: kiểm tra dữ liệu (bỏ qua)

    //B3: hiển thi kết quả
    filterOrderByPizzaType(vPizzaFilterObj);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // Hàm load dữ liệu order ra table
  function loadOrderDataToTable(paramOrderObjects) {
    gOrderDataTable.clear();
    gOrderDataTable.rows.add(paramOrderObjects);
    gOrderDataTable.draw();
  }

  // Hàm load dữ liệu pizza vào selectbox
  function loadPizzaTypeToSelectBox(paramPizzaType) {
    var vPizzaTypeSelect = $("#gPizzaTypeSelect");
    vPizzaTypeSelect.append($("<option>", {
        value:0,
        text:'Chọn loại pizza'
      }))

    for (var bI = 0; bI<paramPizzaType.length; bI++) {
      vPizzaTypeSelect.append($("<option>", {
        value:paramPizzaType[bI].typeId,
        text:paramPizzaType[bI].typeName
      }));
    }
  }
  // hàm trả về pizzaTypeName dựa vào typeId
  function getPizzaNameByTypeId(paramTypeId) {
    "use strict";
    var vPizzaTypeName = "";
    var vIndex = 0;
    var vIsTypeFound = false;
    while(!vIsTypeFound && vIndex < gPizzaType.length) {
      if(gPizzaType[vIndex].typeId === paramTypeId) {
        vIsTypeFound = true;
        vPizzaTypeName = gPizzaType[vIndex].typeName;
      }
      else {
        vIndex ++;
      }
    }
    return vPizzaTypeName;
  }

  //hàm thu thập dữ liệu
  function getFilterData(paramPizzaFilterObj) {
    paramPizzaFilterObj.pizzaTypeId = $("#gPizzaTypeSelect").val();
  }

  //hàm lọc dữ liệu
  function filterOrderByPizzaType(paramPizzaFilterObj) {
    var vResult = [];
    vResult = gOrderObjects.filter(function(pizzaItem) {
      return (paramPizzaFilterObj.pizzaTypeId == 0 || paramPizzaFilterObj.pizzaTypeId == pizzaItem.gPizzaTypeId)
    })

    loadOrderDataToTable(vResult);
  }
</script>
</body>
</html>